<?php
/**
* Topic:    A picture gallery with automated thumbnail generation
*
* @author:  Urs Gehrig <urs_at_circle_dot_ch>
* @version: $Id: autogallery.inc.php,v 1.3 2002-10-07 23:49:53+02 urs_gehrig Exp urs_gehrig $
*
* History:  
*   [2002-10-03]
*       - skipped version numbering and moved to automated cvs numbering
*       - javascript clean up
*       - added a switch for different frame.* templates (gif, png, jpeg)
*   [2001-12-10] Version 0.2.2
*       - added auto-popup-centering
*       - some code clean-up
*   [2001-11-18] Version 0.2.1
*	    - added gallery-handling feature with an index.txt file
*	    - upgraded page indexing
*	    - now, we always know, which gallery we are looking at; added "selected"
*	[2001-04-07] Version 0.2.0
*	    - added more javascript features
*		- some bugfixes
*   [2001-04-02] Version 0.1.0
*	    - initial release
*/

class autogallery
{
    /**
    * Variable declaration
    */
    var $idx     = '';
    var $ref_idx = 0;
    // ... more to come

    /**
    * Class constructor
    *
    * @param    $path, $src, $tpl
    */
    function autogallery($path="./cache", $src="./images/2001", $tpl="./images/frame.png" ) 
    {
        $this->path     = trim($path);
        $this->src      = trim($src);
        $this->tpl      = trim($tpl);

        $this->page     = 'p';
        $this->gallery  = 'g';
        $this->desc     = 'Seite(n): ';
        $this->prefix   = sprintf("%s_", substr(md5($this->src ), 0, 6 ) );
        $this->idxfile  = sprintf("_%s.txt", md5($this->src ) );

        $this->resize();
        $this->checkup();
    }

    /**
    * Print the javascript, which is needed for the popup window
    *
    * @param $pagetitle string
    * @return $str string
    */
    function show_jscript($pagetitle="autogallery" ) 
    {
        // init vars
        $str = '';
        
        $host = "http://" . $_SERVER['SERVER_NAME'] . ($_SERVER['SERVER_PORT'] == 80 ? "" : ":" . $_SERVER['SERVER_PORT'] )
                . (strlen($_SERVER['PHP_SELF']) ? "" . str_replace(basename($_SERVER['PHP_SELF']), "", $_SERVER['PHP_SELF'] ) : "");

        $str .= "\n<script language=\"JavaScript\">\n";
        $str .= "<!--\n";
        $str .= "function popup (img,sx,sy,num) {\n";
        $str .= "		 var winl = (screen.width-sx)/2;\n";
        $str .= "		 var wint = (screen.height-sy)/2;\n";
        $str .= "    image = \"<a href='javascript:self.close()'><img src='\"+img+\"' border='0' alt='Click to Close'></a>\";\n";
        $str .= "    popupwin=window.open(\"\",\"photo\"+num,\"toolbar=no,location=no,directories=no,status=no,menubar=no,top=\"+wint+\",left=\"+winl+\",width=\"+sx+\",height=\"+sy+\"\");\n";
        $str .= sprintf("    popupwin.document.write(\"<HTML><HEAD><TITLE>%s</TITLE><BASE HREF=\\%s\\></HEAD><BODY BGCOLOR=#FFFFFF><CENTER>\" + image + \"</CENTER></BODY></HTML>\");\n", $pagetitle, $host );
        $str .= "    popupwin.document.close();\n";
        $str .= "}\n";
        $str .= "// -->\n";
        $str .= "</script>\n";

        return $str;
    }

    /**
    * Construct a selection menu based on an array passed to the method
    *
    * @param array $multiple
    */
    function select_gallery($multiple=array() ) 
    {

        // reset page-index to page 1
        $_GET[$this->page] = 0;

        // construct selection-form
        $str  = '';
        $str .= "\n<form name=\"navigator\" method=\"get\" action=\"GET\">\n";
        $str .= "<select name=\"navMenu\" size=\"1\" onChange=\"if( this.options[this.selectedIndex].value != '' ) document.location = this.options[this.selectedIndex].value\">\n";
        $str .= "    <option>select ...</option>\n";

        foreach($multiple AS $key => $val) 
        {
            $str .= sprintf("    <option value=\"?%s\" %s>%s</option>\n",
                            $this->url($this->gallery, "$this->gallery=$key" ),
                            ($_GET[$this->gallery] == $key ? "selected" : ""),
                            trim($multiple[$key][3] )
                    );
        }
        $str .= "</select>\n";
        $str .= "</form>\n\n";

        return $str;
    }


    /**
    * Resizes jp(e)g files within the $src-directory and stores
    * the thumbnails in the $path-directory by adding a "_" to the filename.
    */
    function resize() 
    {

        $count = 0;
        $d = dir($this->src );
        $fp = fopen("$this->path/$this->idxfile", "a+" );

        while($entry=$d->read() ) 
        {
            if(eregi(".+\.jp[e]{0,1}g$", $entry )) {

                if(!file_exists("$this->path/_$this->prefix$entry" )) {
                    $src = ImageCreateFromJPEG("$d->path/$entry" );

                    $org_h = imagesy($src );
                    $org_w = imagesx($src );

                    // get size of template image
                    $tpl_size = GetImageSize("$this->tpl" );

                    if($org_h > $org_w ) 
                    {
                        // height is bigger than width
                        $cfg[height] = $tpl_size[1];
                        $cfg[width]  = floor($cfg[height] * $org_w / $org_h );
                        $cfg[dstX]   = ($tpl_size[0] - $cfg[width]) / 2;
                        $cfg[dstY]   = 0;
                    } 
                    else {
                        // width is bigger than height
                        $cfg[width]  = $tpl_size[0];
                        $cfg[height] = floor($cfg[width] * $org_h / $org_w );
                        $cfg[dstX]   = 0;
                        $cfg[dstY]   = ($tpl_size[1] - $cfg[height]) / 2;
                    }
                    
                    switch($tpl_size[2]) 
                    {
                        case '3':
                            $img = ImageCreateFromPNG("$this->tpl" );
                            break;
                        case '2':
                            $img = ImageCreateFromJPEG("$this->tpl" );
                            break;
                        case '1':
                            $img = ImageCreateFromGIF("$this->tpl" );
                            break;
                    }
                    
                    ImageCopyResized($img, $src, $cfg[dstX], $cfg[dstY], 0, 0, $cfg[width], $cfg[height], $org_w, $org_h );
                    ImageJPEG($img, "$this->path/_$this->prefix$entry", 90 );
                    ImageDestroy($img );

                    // create an index file with "thumbnailfile, filename, width, height"
                    if(!strstr(join("", file("$this->path/$this->idxfile") ), $entry )) {
                        fwrite($fp, "_$this->prefix$entry,$entry,$org_w,$org_h"."\n", strlen("_$this->prefix$entry,$entry,$org_w,$org_h"."\n" ));
                    }
                }
            }
        }

        fclose($fp);
        $d->close();
    }

    /**
    * Clean-up cache images where there is no original image and update indexlist
    *
    */
    function checkup() 
    {
        $ref_idx = 0;
        
        // get the current indexfile
        $idx = file("$this->path/$this->idxfile" );
        $i=0;

        // make a reference string
        $d = dir($this->src );
        while($entry=$d->read() ) {
            $ref_idx .= "$entry,";
        }
        $d->close();

        // crosscheck for obsolete thumbnails
        for($f=0; $f<count($idx); $f++) {
            $items = explode(",", $idx[$f] );

            if(strstr($ref_idx, trim($items[1]) )) {
                $new_idx[$i++] = trim($idx[$f])."\n";
            } else {
                if(file_exists("$this->path/".$items[0])) unlink("$this->path/".$items[0] );
            }
        }

        // update indexfile
        $fp = fopen("$this->path/$this->idxfile", "w+" );
        for($k=0; $k<count($new_idx); $k++) {
            fwrite($fp, trim($new_idx[$k])."\n", strlen(trim($new_idx[$k])."\n" ));
        }
        fclose($fp);

    }

    /**
    * Make an html table with thumbnail-links
    *
    * @param    $cols, $rows, $multiple
    * @return   $table string
    */
    function thumbnail_table($cols=3, $rows=3, $multiple=array() ) 
    {
        // init vars
        $idx = $k = $_page = 0;
        
        // get indexfile
        $idx = file("$this->path/$this->idxfile");

        // calculate start and end of page index
        $_page = "$this->page";
        $cfg['start'] = $_GET[$_page] * $cols * $rows;
        $cfg['stop']  = ($_GET[$_page] + 1 ) * $cols * $rows;

        $table  = '';
        $table .= "\n<!-- image gallery -->\n";
        $table .= "<table border=\"0\" cellpadding=\"10\" cellspacing=\"0\" align=\"center\">\n<tr>\n";
        $table .= "<tr><td colspan=$cols align=\"right\">" . $this->select_gallery($multiple ) . "</td>\n<tr>\n";

        // construct table
        for($j=$cfg['start']; $j<$cfg['stop']; $j++ ) {
            $itemlist = explode(",", $idx[$j] );
            if(eregi(".+\.jp[e]{0,1}g$", $itemlist[1] )) {

                $table .= sprintf("<td><a href=\"javascript:popup('%s',%s,%s,$j);\"
                                  onMouseOver=\"window.status='Click'; return true;\"
                                  onMouseOut=\"window.status=''; return true;\"><img
                                  src=\"%s\" alt=\"Click\"
                                  border=\"0\"></a></td>\n",
                                  "$this->src/".$itemlist[1],
                                  $itemlist[2]+20,
                                  $itemlist[3]+20,
                                  "$this->path/".$itemlist[0] );
                $k++;
                if($k == $cols ) {
                    $table .= "</tr>\n<tr>\n";
                    $k = 0;
                }
            }
        }
        $table .= "</tr>\n<tr><td colspan=\"$cols\">";

        // create page index
        $table .= "$this->desc";

        for($n=0, $l=0; $size=count($idx), $n<$size; $n=$n+($cols*$rows) ) {

            if($_REQUEST[$_page] == $l) {
                $table .= sprintf("%s\n", ++$l );
            } else {
                $table .= sprintf("<a href=\"?%s\">%s</a>\n", $this->url($_page, "$_page=$l" ), ++$l );
            }
        }
        
        $table .= "</td></tr>\n</table>\n";
        $table .= "<!-- /image gallery -->\n";

        return $table;
    }

    /**
    * Proper handling of query-string to make this script
    * application-independent and easy-integratable.
    *
    * @param $index, $addon
    * @return $str, $addon, $tmp string
    */
    function url($index="page", $addon="" ) 
    {
        $str = $tmp = '';
        
        // a dirty hack for those who use arrays in the query string
        foreach($_GET as $key => $val ) {
            if(is_array($val) == "array") {
                $tmp .= "&" . $key . "[" . key($val) . "]=" . current($val);
            } else {
                $q[$key] = $val;
            }
        }

        if(is_array($q )) {
            // remove $index element from the list
            unset($q[$index]);

            // create new query-string
            foreach($q as $key => $val ) {
                $str .= "$key=$val&";
            }
            return $str . $addon . $tmp;
        } else {
            return $addon . $tmp;
        }
    }
}
?>